---
title: llarp::layers::flow::FlowLayer
summary: flow layer's context that holds all the things in the flow layer 

---

# llarp::layers::flow::FlowLayer



flow layer's context that holds all the things in the flow layer 


`#include <flow_layer.hpp>`

## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[FlowLayer](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer.md#function-flowlayer)**([AbstractRouter](Classes/structllarp_1_1AbstractRouter.md) & , [NetworkConfig](Classes/structllarp_1_1NetworkConfig.md) ) |
| | **[~FlowLayer](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer.md#function-~flowlayer)**() |
| | **[FlowLayer](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer.md#function-flowlayer)**(const [FlowLayer](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer.md) & ) =delete |
| | **[FlowLayer](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer.md#function-flowlayer)**([FlowLayer](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer.md) && ) =delete |
| [FlowStats](Classes/structllarp_1_1layers_1_1flow_1_1FlowStats.md) | **[current_stats](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer.md#function-current-stats)**() const<br>get flow layer's informational stats at this moment in time.  |
| [FlowAddr](Classes/classllarp_1_1layers_1_1flow_1_1FlowAddr.md) | **[local_addr](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer.md#function-local-addr)**() const |
| [FlowIdentity](Classes/classllarp_1_1layers_1_1flow_1_1FlowIdentity.md) & | **[best_flow_to](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer.md#function-best-flow-to)**(const [FlowAddr](Classes/classllarp_1_1layers_1_1flow_1_1FlowAddr.md) & addr)<br>get the best flow to a remote address, autovivifies  |
| void | **[offer_flow_traffic](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer.md#function-offer-flow-traffic)**([FlowTraffic](Classes/structllarp_1_1layers_1_1flow_1_1FlowTraffic.md) && traff)<br>get the local identity for a flow tag if it exists  |
| void | **[start](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer.md#function-start)**() |
| void | **[stop](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer.md#function-stop)**() |

## Public Attributes

|                | Name           |
| -------------- | -------------- |
| [NameResolver](Classes/classllarp_1_1layers_1_1flow_1_1NameResolver.md) | **[name_resolver](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer.md#variable-name-resolver)**  |
| [AbstractRouter](Classes/structllarp_1_1AbstractRouter.md) & | **[router](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer.md#variable-router)**  |

## Public Functions Documentation

### function FlowLayer

```cpp
FlowLayer(
    AbstractRouter & ,
    NetworkConfig 
)
```


### function ~FlowLayer

```cpp
~FlowLayer()
```


### function FlowLayer

```cpp
FlowLayer(
    const FlowLayer & 
) =delete
```


### function FlowLayer

```cpp
FlowLayer(
    FlowLayer && 
) =delete
```


### function current_stats

```cpp
FlowStats current_stats() const
```

get flow layer's informational stats at this moment in time. 

### function local_addr

```cpp
inline FlowAddr local_addr() const
```


### function best_flow_to

```cpp
FlowIdentity & best_flow_to(
    const FlowAddr & addr
)
```

get the best flow to a remote address, autovivifies 

### function offer_flow_traffic

```cpp
void offer_flow_traffic(
    FlowTraffic && traff
)
```

get the local identity for a flow tag if it exists 

synthetically inject flow layer traffic into the flow layer 


### function start

```cpp
void start()
```


### function stop

```cpp
void stop()
```


## Public Attributes Documentation

### variable name_resolver

```cpp
NameResolver name_resolver;
```


### variable router

```cpp
AbstractRouter & router;
```


-------------------------------

Updated on 2023-02-23 at 21:24:54 +0000