---
title: llarp::layers::platform::DNS_NameResolver_Glue
summary: glues together NameResolver and dns::Resolver_Base

---

# llarp::layers::platform::DNS_NameResolver_Glue



glues together [NameResolver]() and [dns::Resolver_Base](Classes/classllarp_1_1dns_1_1Resolver__Base.md)


`#include <deprecated_driver_pimpl.hpp>`

Inherits from [llarp::dns::Resolver_Base](Classes/classllarp_1_1dns_1_1Resolver__Base.md), std::enable_shared_from_this< DNS_NameResolver_Glue >

## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[DNS_NameResolver_Glue](Classes/classllarp_1_1layers_1_1platform_1_1DNS__NameResolver__Glue.md#function-dns-nameresolver-glue)**([NameResolver](Classes/classllarp_1_1layers_1_1platform_1_1NameResolver.md) & name_resolver, [flow::FlowLayer](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer.md) & flow_layer) |
| virtual std::string_view | **[ResolverName](Classes/classllarp_1_1layers_1_1platform_1_1DNS__NameResolver__Glue.md#function-resolvername)**() const override<br>get printable name  |
| virtual bool | **[MaybeHookDNS](Classes/classllarp_1_1layers_1_1platform_1_1DNS__NameResolver__Glue.md#function-maybehookdns)**(std::shared_ptr< [dns::PacketSource_Base](Classes/classllarp_1_1dns_1_1PacketSource__Base.md) > source, const [dns::Message](Classes/structllarp_1_1dns_1_1Message.md) & query, const [SockAddr](Classes/structllarp_1_1SockAddr.md) & to, const [SockAddr](Classes/structllarp_1_1SockAddr.md) & from) override<br>attempt to handle a dns message returns true if we consumed this query and it should not be processed again  |

## Protected Functions

|                | Name           |
| -------------- | -------------- |
| virtual int | **[Rank](Classes/classllarp_1_1layers_1_1platform_1_1DNS__NameResolver__Glue.md#function-rank)**() const override<br>return the sorting order for this resolver lower means it will be tried first  |

## Additional inherited members

**Public Functions inherited from [llarp::dns::Resolver_Base](Classes/classllarp_1_1dns_1_1Resolver__Base.md)**

|                | Name           |
| -------------- | -------------- |
| virtual | **[~Resolver_Base](Classes/classllarp_1_1dns_1_1Resolver__Base.md#function-~resolver-base)**() =default |
| bool | **[operator<](Classes/classllarp_1_1dns_1_1Resolver__Base.md#function-operator<)**(const [Resolver_Base](Classes/classllarp_1_1dns_1_1Resolver__Base.md) & other) const<br>less than via rank  |
| bool | **[operator>](Classes/classllarp_1_1dns_1_1Resolver__Base.md#function-operator>)**(const [Resolver_Base](Classes/classllarp_1_1dns_1_1Resolver__Base.md) & other) const<br>greater than via rank  |
| virtual std::optional< [SockAddr](Classes/structllarp_1_1SockAddr.md) > | **[GetLocalAddr](Classes/classllarp_1_1dns_1_1Resolver__Base.md#function-getlocaladdr)**() const<br>get local socket address that queries are sent from  |
| virtual void | **[ResetResolver](Classes/classllarp_1_1dns_1_1Resolver__Base.md#function-resetresolver)**(] std::optional< std::vector< [SockAddr](Classes/structllarp_1_1SockAddr.md) >> replace_upstream =std::nullopt)<br>reset the resolver state, optionally replace upstream info with new info.  |
| virtual void | **[Down](Classes/classllarp_1_1dns_1_1Resolver__Base.md#function-down)**()<br>cancel all pending requests and cease further operation. Default operation is a no-op.  |


## Public Functions Documentation

### function DNS_NameResolver_Glue

```cpp
inline DNS_NameResolver_Glue(
    NameResolver & name_resolver,
    flow::FlowLayer & flow_layer
)
```


### function ResolverName

```cpp
inline virtual std::string_view ResolverName() const override
```

get printable name 

**Reimplements**: [llarp::dns::Resolver_Base::ResolverName](Classes/classllarp_1_1dns_1_1Resolver__Base.md#function-resolvername)


### function MaybeHookDNS

```cpp
inline virtual bool MaybeHookDNS(
    std::shared_ptr< dns::PacketSource_Base > source,
    const dns::Message & query,
    const SockAddr & to,
    const SockAddr & from
) override
```

attempt to handle a dns message returns true if we consumed this query and it should not be processed again 

**Reimplements**: [llarp::dns::Resolver_Base::MaybeHookDNS](Classes/classllarp_1_1dns_1_1Resolver__Base.md#function-maybehookdns)


## Protected Functions Documentation

### function Rank

```cpp
inline virtual int Rank() const override
```

return the sorting order for this resolver lower means it will be tried first 

**Reimplements**: [llarp::dns::Resolver_Base::Rank](Classes/classllarp_1_1dns_1_1Resolver__Base.md#function-rank)


-------------------------------

Updated on 2023-02-23 at 21:24:54 +0000