---
title: llarp::layers::Layers
summary: a holder type that abstracts out how lokinet works at each layer. 

---

# llarp::layers::Layers



a holder type that abstracts out how lokinet works at each layer.  [More...](#detailed-description)


`#include <layers.hpp>`

## Public Functions

|                | Name           |
| -------------- | -------------- |
| void | **[start_all](Classes/structllarp_1_1layers_1_1Layers.md#function-start-all)**() const |
| void | **[stop_all](Classes/structllarp_1_1layers_1_1Layers.md#function-stop-all)**() const |

## Public Attributes

|                | Name           |
| -------------- | -------------- |
| std::unique_ptr< [platform::PlatformLayer](Classes/classllarp_1_1layers_1_1platform_1_1PlatformLayer.md) > | **[platform](Classes/structllarp_1_1layers_1_1Layers.md#variable-platform)**  |
| std::unique_ptr< [flow::FlowLayer](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer.md) > | **[flow](Classes/structllarp_1_1layers_1_1Layers.md#variable-flow)**  |
| std::unique_ptr< [route::RouteLayer](Classes/classllarp_1_1layers_1_1route_1_1RouteLayer.md) > | **[route](Classes/structllarp_1_1layers_1_1Layers.md#variable-route)**  |
| std::unique_ptr< [onion::OnionLayer](Classes/classllarp_1_1layers_1_1onion_1_1OnionLayer.md) > | **[onion](Classes/structllarp_1_1layers_1_1Layers.md#variable-onion)**  |

## Detailed Description

```cpp
struct llarp::layers::Layers;
```

a holder type that abstracts out how lokinet works at each layer. 

this is owned by [AbstractRouter](Classes/structllarp_1_1AbstractRouter.md), and in time all the members on this will be moved to [AbstractRouter](Classes/structllarp_1_1AbstractRouter.md). 

## Public Functions Documentation

### function start_all

```cpp
void start_all() const
```


### function stop_all

```cpp
void stop_all() const
```


## Public Attributes Documentation

### variable platform

```cpp
std::unique_ptr< platform::PlatformLayer > platform;
```


### variable flow

```cpp
std::unique_ptr< flow::FlowLayer > flow;
```


### variable route

```cpp
std::unique_ptr< route::RouteLayer > route;
```


### variable onion

```cpp
std::unique_ptr< onion::OnionLayer > onion;
```


-------------------------------

Updated on 2023-02-23 at 21:24:54 +0000