---
title: llarp/layers/route/destination.hpp

---

# llarp/layers/route/destination.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::layers](Namespaces/namespacellarp_1_1layers.md)**  |
| **[llarp::layers::route](Namespaces/namespacellarp_1_1layers_1_1route.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| class | **[llarp::layers::route::Destination](Classes/classllarp_1_1layers_1_1route_1_1Destination.md)** <br>a routable destination when we are an endpoint router transiting routing layer traffic.  |




## Source code

```cpp
#pragma once

#include <llarp/crypto/types.hpp>
#include <optional>
#include "llarp/layers/flow/flow_addr.hpp"
#include "llarp/layers/flow/flow_info.hpp"
#include "llarp/path/path_types.hpp"
#include "llarp/path/transit_hop.hpp"

namespace llarp::layers::route
{
  class Destination
  {
   public:
    PubKey src;
    PubKey dst;
    path::TransitHopInfo onion_info;

    std::optional<flow::FlowInfo> flow_info;
  };
}  // namespace llarp::layers::route
```


-------------------------------

Updated on 2023-02-23 at 21:24:54 +0000
