---
title: llarp/layers/platform/dns_bridge.hpp

---

# llarp/layers/platform/dns_bridge.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::layers](Namespaces/namespacellarp_1_1layers.md)**  |
| **[llarp::layers::platform](Namespaces/namespacellarp_1_1layers_1_1platform.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| class | **[llarp::layers::platform::DNSZone](Classes/classllarp_1_1layers_1_1platform_1_1DNSZone.md)**  |
| class | **[llarp::layers::platform::DNSQueryHandler](Classes/classllarp_1_1layers_1_1platform_1_1DNSQueryHandler.md)** <br>handles dns queries, for .loki / .snode  |




## Source code

```cpp
#pragma once

#include <llarp/dns/server.hpp>
#include <memory>
#include "llarp/dns/srv_data.hpp"
namespace llarp::layers::platform
{

  class PlatformLayer;

  class DNSZone
  {
   public:
    void
    add_srv_record(dns::SRVTuple srv);
  };

  class DNSQueryHandler : public dns::Resolver_Base
  {
    PlatformLayer& _parent;

   public:
    DNSQueryHandler(PlatformLayer& parent);
  };
}  // namespace llarp::layers::platform
```


-------------------------------

Updated on 2023-02-23 at 21:24:54 +0000
