---
title: llarp/layers/flow/flow_state.hpp

---

# llarp/layers/flow/flow_state.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::layers](Namespaces/namespacellarp_1_1layers.md)**  |
| **[llarp::layers::flow](Namespaces/namespacellarp_1_1layers_1_1flow.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| class | **[llarp::layers::flow::FlowState_Base](Classes/classllarp_1_1layers_1_1flow_1_1FlowState__Base.md)** <br>internal state of a flow on the flow layer.  |




## Source code

```cpp
#pragma once

#include "flow_auth.hpp"

namespace llarp::layers::flow
{

  class FlowState_Base
  {
   public:
    FlowState_Base(const FlowState_Base&) = delete;
    FlowState_Base(FlowState_Base&&) = delete;

    bool
    paths_aligned() const;

    bool
    requires_authentication() const;


    FlowAuthPhase
    auth_phase() const;

    bool
    established() const;
  };

}  // namespace llarp::layers::flow
```


-------------------------------

Updated on 2023-02-23 at 21:24:54 +0000
